local CircleExpand = class("CircleExpand",Animation)

function CircleExpand:initialize(x,y,r,g,b,target_r,speed,fade_speed)
	Animation.initialize(self,x,y)
	self.r,self.g,self.b = r,g,b
	self.current_r = 0
	self.target_r = target_r
	self.speed = speed or 10
	self.fade_speed = fade_speed or 1
	self.openSet = {}
	self.closedSet = {}
end

function CircleExpand:update(dt,map)
	if self.current_r < self.target_r + 1 then self.current_r = self.current_r + self.speed*dt end
	for x in ipairs(map) do
		for y in ipairs(map[x]) do
			local _string = string.format("%d.%d",x,y)
			if not self.openSet[_string] and not self.closedSet[_string] and (x-self.x)^2+(y-self.y)^2 < self.current_r^2 and (x-self.x)^2+(y-self.y)^2 < self.target_r^2 then
					self.openSet[_string] = {x = x, y = y, duration = 1, check = false}
			end
		end
	end
	for i,v in pairs(self.openSet) do
		v.duration = v.duration - 1*self.fade_speed*dt
		if self.action and not v.check then
			v.check = true
			self:action(v.x,v.y,map)
		end
		if v.duration <= 0 then
			self.closedSet[i] = true
			self.openSet[i] = nil
		end
	end
	if tableLength(self.openSet) == 0 then self.finished = true end
end

function CircleExpand:draw()
	for i,v in pairs(self.openSet) do
		drawTile(12,14,v.x,v.y,self.r,self.g,self.b,nil,nil,nil,v.duration*255)
	end
end

return CircleExpand