local Item = class("Item")

function Item:initialize(t)
	for k,v in pairs(t) do
		self[k] = v
	end
end

function Item:update()
	if self.cooldown and self.cooldown > 0 then self.cooldown = self.cooldown - 1 end
end

function Item:getAttack(entity)
	local total_attack = 0
	if self.attack then
		total_attack = total_attack + self.attack
	end
	return total_attack
end

function Item:getArmor(entity)
	local total_armor = 0
	if self.armor then
		total_armor = total_armor + self.armor
	end
	return total_armor
end

function Item:getGraphics()
	local qx,qy,r,g,b,br,bg,bb,a
	local qx,qy = self.graphics.qx,self.graphics.qy
	if self.uncommon then
		r,g,b = 255,255,100
	elseif self.rare then
		r,g,b = 0,100,200
	elseif self.epic then
		r,g,b = 150,0,150
	elseif self.mythical then
		r,g,b = math.random(100,200),math.random(100,200),math.random(100,200)
	else
		r,g,b = 200,200,200
	end
	return qx,qy,r,g,b,br,bg,bb,a
end

return Item