local Kobold = class("Kobold",Entity)

local kobold_property = {
	name = "kobold",
	graphics = {qx = 12, qy = 7, r = 0, g = 200, b = 0},
	attack = 10,
	maxHp = 20
	}

function Kobold:initialize()
	Entity.initialize(self, kobold_property)
end

function Kobold:action(map)
	local cx,cy = map:findEntity(self.id)
	local tx,ty = map:findEntity("hero")
	if not tx then self:rest(); return end
	if distBetween(cx,cy,tx,ty) <= 1000 then
		local path = self:pathfinding(map,cx,cy,tx,ty)
		if not path then
			self:rest()
		else
			local nx,ny = path[1].x,path[1].y
			self:interact(nx,ny,cx,cy,map)
		end
	else
		self:rest()
	end
	Entity.action(self,map)
end

return Kobold