local play = {}

function play:load(_load)
	self.subgamestate = "playing"
	if _load then
		self.dungeon = loadGame()
	else
		self.dungeon = {}
		for i = 1, 50 do
			self.dungeon[i] = Map:new(51,51,i)
		end
		self.dungeon.current_floor = 1
		self.hero = Hero:new()
		self.dungeon[self.dungeon.current_floor] = Map:new(51,51,current_floor)
		self.dungeon[self.dungeon.current_floor]:createEntity(self.hero,20,20)
		self.dungeon[self.dungeon.current_floor]:createEntity(Kobold:new(),10,10)
		self.dungeon[self.dungeon.current_floor]:createEntity(Kobold:new(),12,12)
		self.dungeon[self.dungeon.current_floor]:createEntity(Kobold:new(),14,14)
		self.dungeon[self.dungeon.current_floor]:createEntity(Kobold:new(),15,15)
		self.dungeon[self.dungeon.current_floor]:createEntity(Kobold:new(),25,15)
		self.dungeon[self.dungeon.current_floor]:createEntity(Kobold:new(),35,15)
		self.dungeon[self.dungeon.current_floor]:createEntity(Kobold:new(),45,15)
		self.dungeon[self.dungeon.current_floor]:createEntity(Kobold:new(),15,25)
		self.dungeon[self.dungeon.current_floor]:createEntity(Kobold:new(),15,35)
		self.dungeon[self.dungeon.current_floor]:createEntity(Kobold:new(),15,45)
		self.dungeon[self.dungeon.current_floor]:insertItem(Scroll:new(),21,20)
		self.dungeon[self.dungeon.current_floor]:insertItem(Potion:new(),20,21)
	end
	self.currentLog = EventLog:new()
	self.targetPos = false
end

function play:update(dt)
	self.dungeon[self.dungeon.current_floor]:update(dt)
end

function play:keypressed(key)
	local map = self.dungeon[self.dungeon.current_floor]
	if key == "f1" then
		saveGame(self.dungeon)
	elseif key == "f2" then
		self.dungeon = loadGame()
	elseif key == "f3" then deleteSavefile()
	elseif key == "escape" then
		if self.subgamestate ~= "playing" then self.subgamestate = "playing"
		else self.subgamestate = "game_menu" end
	end
	if self.subgamestate == "playing" then self.hero:keyInput(key,map) end
end

function play:draw()
	self.dungeon[self.dungeon.current_floor]:draw()
	self.currentLog:draw()
	self.hero:UI()
end

return play