tileset = love.graphics.newImage("Potash.png")
tilesetQuads = {}
for x = 1, 16 do
	tilesetQuads[x] = {}
	for y = 1, 16 do
		tilesetQuads[x][y] = love.graphics.newQuad(10*(x-1),10*(y-1),10,10,160,160)
	end
end

function drawTile(qx,qy,gx,gy,r,g,b,br,bg,bb,a)
	local r = r or 255
	local g = g or 255
	local b = b or 255
	local br = br or 0
	local bg = bg or 0
	local bb = bb or 0
	local a = a or 255
	local ba = ba or 255
	--Draw Background
	if ba > 0 then
		love.graphics.setColor(br,bg,bb,a)
		love.graphics.rectangle("fill",10*(gx-1),10*(gy-1),10,10)
	end
	--Draw Foreground
	if a > 0 then
		love.graphics.setColor(r,g,b,a)
		love.graphics.draw(tileset,tilesetQuads[qx][qy],10*(gx-1),10*(gy-1))
	end
end

function drawText(text,x,y,widthLimit,heightLimit)
	local canvas = love.graphics.newCanvas()
	love.graphics.setCanvas(canvas)
	local widthLimit = widthLimit or 80
	local heightLimit = heightLimit or 60
	local dx,dy = 0,0
	local colorShift = false
	local backColorShift = false
	local newColor = ""
	local r,g,b = 255,255,255
	local ba = 0
	for letter in text:gmatch(".") do
		if letter == "<" then
			love.graphics.setColor(255,255,255,255)
			colorShift = true
		end
		if colorShift then
			if letter == ">" then
				colorShift = false
				if newColor == "" then newColor = "white" end
				r,g,b = color_RGB[newColor].r,color_RGB[newColor].g,color_RGB[newColor].b
				newColor = ""
			else
				if letter ~= "<" then
					newColor = newColor..letter
				end
			end
		elseif letter == "\n" then
			dy = dy + 1
			dx = 0
			if dy > heightLimit then break end
		else
			local qx,qy = glyph_quads[letter].qx, glyph_quads[letter].qy
			drawTile(qx,qy,x+dx,y+dy,r,g,b,nil,nil,nil,250,0)
			dx = dx + 1
			if dx > widthLimit then
				dy = dy + 1
				dx = 0
			end
			if dy > heightLimit then break end
		end
	end
	love.graphics.setCanvas()
	love.graphics.draw(canvas)
end

glyph_quads = {
	["'"] = {qx=8,qy=3},
	[" "] = {	qy	=	1,	qx	=	1},
	["0"] = {	qy	=	4,	qx	=	1},
	["1"] = {	qy	=	4,	qx	=	2},
	["2"] = {	qy	=	4,	qx	=	3},
	["3"] = {	qy	=	4,	qx	=	4},
	["4"] = {	qy	=	4,	qx	=	5},
	["5"] = {	qy	=	4,	qx	=	6},
	["6"] = {	qy	=	4,	qx	=	7},
	["7"] = {	qy	=	4,	qx	=	8},
	["8"] = {	qy	=	4,	qx	=	9},
	["9"] = {	qy	=	4,	qx	=	10},
	["!"] = {	qy	=	3,	qx	=	2},
	["?"] = {	qy	=	4,	qx	=	16},
	[":"] = {	qy	=	4,	qx	=	11},
	["."] = {	qy	=	3,	qx	=	15},
	["-"] = {	qy	=	3,	qx	=	14},
	["("] = {	qy	=	3,	qx	=	9},
	[")"] = {	qy	=	3,	qx	=	10},
	["%"] = {	qy	=	3,	qx	=	6},
	["#"] = {	qy	=	4,	qx	=	4},
	["&"] = {	qy	=	7,	qx	=	3},
	["~"] = {	qx	=	15,	qy	=	8},
	A = {	qy	=	5,	qx	=	2},
	B = {	qy	=	5,	qx	=	3},
	C = {	qy	=	5,	qx	=	4},
	D = {	qy	=	5,	qx	=	5},
	E = {	qy	=	5,	qx	=	6},
	F = {	qy	=	5,	qx	=	7},
	G = {	qy	=	5,	qx	=	8},
	H = {	qy	=	5,	qx	=	9},
	I = {	qy	=	5,	qx	=	10},
	J = {	qy	=	5,	qx	=	11},
	K = {	qy	=	5,	qx	=	12},
	L = {	qy	=	5,	qx	=	13},
	M = {	qy	=	5,	qx	=	14},
	N = {	qy	=	5,	qx	=	15},
	O = {	qy	=	5,	qx	=	16},
	P = {	qy	=	6,	qx	=	1},
	Q = {	qy	=	6,	qx	=	2},
	R = {	qy	=	6,	qx	=	3},
	S = {	qy	=	6,	qx	=	4},
	T = {	qy	=	6,	qx	=	5},
	U = {	qy	=	6,	qx	=	6},
	V = {	qy	=	6,	qx	=	7},
	W = {	qy	=	6,	qx	=	8},
	X = {	qy	=	6,	qx	=	9},
	Y = {	qy	=	6,	qx	=	10},
	Z = {	qy	=	6,	qx	=	11},
	a = {	qy	=	7,	qx	=	2},
	b = {	qy	=	7,	qx	=	3},
	c = {	qy	=	7,	qx	=	4},
	d = {	qy	=	7,	qx	=	5},
	e = {	qy	=	7,	qx	=	6},
	f = {	qy	=	7,	qx	=	7},
	g = {	qy	=	7,	qx	=	8},
	h = {	qy	=	7,	qx	=	9},
	i = {	qy	=	7,	qx	=	10},
	j = {	qy	=	7,	qx	=	11},
	k = {	qy	=	7,	qx	=	12},
	l = {	qy	=	7,	qx	=	13},
	m = {	qy	=	7,	qx	=	14},
	n = {	qy	=	7,	qx	=	15},
	o = {	qy	=	7,	qx	=	16},
	p = {	qy	=	8,	qx	=	1},
	q = {	qy	=	8,	qx	=	2},
	r = {	qy	=	8,	qx	=	3},
	s = {	qy	=	8,	qx	=	4},
	t = {	qy	=	8,	qx	=	5},
	u = {	qy	=	8,	qx	=	6},
	v = {	qy	=	8,	qx	=	7},
	w = {	qy	=	8,	qx	=	8},
	x = {	qy	=	8,	qx	=	9},
	y = {	qy	=	8,	qx	=	10},
	z = {	qy	=	8,	qx	=	11}
}
color_RGB = {
	white = {r=255,g=255,b=255},
	red = {r=255,g=0,b=0},
	green = {r=0,g=255,b=0},
	blue = {r=0,g=0,b=255}
}