function distBetween(ax,ay,bx,by)
	return math.sqrt((ax-bx)^2+(ay-by)^2)
end

function deltaBetween(ax,ay,bx,by)
	return (ax-bx)/math.abs(ax-bx),(ay-by)/math.abs(ay-by)
end

function capitalize(str)
	return str:gsub("^%l",string.upper)
end

function sortInventory(a,b)
	local a_point, b_point = 0
	local ranking = {uncommon = 1, rare = 2, epic = 3, mythical = 4}
	for i,v in ipairs(ranking) do
		if a.i then a_point = a_point + 10^v end
		if b.i then b_point = b_point + 10^v end
	end
	if a_point > b_point then return true end
end

function revTable(t)
	local rev_t = {}
	for i,v in ipairs(t) do
		rev_t[v] = i
	end
	return rev_t
end

function tableLength(t)
	local length = 0
	for k,v in pairs(t) do length = length + 1 end
	return length
end

function line(x1,y1,x2,y2)
	local path = {}
	local deltaX = x2-x1
	local ix = 1
	if deltaX < 0 then ix = -1 end
	local deltaY = y2-y1
	local iy = 1
	if deltaY < 0 then iy = -1 end
	if deltaX == 0 then
		for y = y1,y2,iy do
			table.insert(path,{x = x1,y = y})
		end
	elseif deltaY == 0 then
		for x = x1,x2,ix do
			table.insert(path,{x = x,y = y1})
		end
	else
		local angle = deltaY/deltaX
		if math.abs(angle) <= 1 then
			local currentY = y1
			for x = x1,x2,ix do
				local actualY = angle*(x-x1)+y1
				if math.abs(actualY - currentY) >= 0.5 then currentY = currentY + iy end
				table.insert(path,{x = x, y = currentY})
			end
		else
			local currentX = x1
			for y = y1,y2,iy do
				local actualX = (1/angle)*(y-y1)+x1
				if math.abs(actualX - currentX) >= 0.5 then currentX = currentX + ix end
				table.insert(path,{x = currentX, y = y})
			end
		end
	end
	return path
end